//
//  TINET (TCP/IP Protocol Stack)
// 
//  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
//                   Tomakomai National College of Technology, JAPAN
//  Copyright (C) 2008-2009 by Hokkaido Industrial Research Institute, JAPAN
//
//  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
//  ˤäƸɽƤ GNU General Public License  Version 2 ˵
//  ҤƤ˸¤ꡤܥեȥܥեȥ
//  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
//  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
//  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
//      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
//      ˴ޤޤƤ뤳ȡ
//  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
//      ѤǤǺۤˤϡۤȼɥȡ
//      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
//      ̵ݾڵǺܤ뤳ȡ
//  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
//      ѤǤʤǺۤˤϡξȡ
//    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
//        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
//  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
//      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
//
//  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
//  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
//  ޤơʤݾڤԤʤޤܥեȥѤˤľ
//  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
// 
//  @(#) $Id: tinet_staticapi.cpp,v 1.5 2009/12/24 05:39:31 abe Exp abe $
//

#include "base/parser.h"

#include "tinet_defs.h"

#include <iostream>

// ֤̾λ

using namespace std;

//
// include API
//

DECLARE_API (INCLUDE, "INCLUDE")
{
	Token		token;
	Directory*	node;
	Directory*	scope;

	last = NULL;
	p.getToken(token, Token::STRINGLITERAL);
	token.chopLiteral();

	if ((token[0] != '\"' || token[token.size() - 1] != '\"') &&
	    (token[0] != '<'  || token[token.size() - 1] != '>' ))
		ExceptionMessage("An include filename must be enclosed with \"...\" or <...>",
		                 "ե̾ \"...\"  <...> ηǤʤФʤޤ").throwException();

	node = container.openChild(OBJECT_TREE, INCLUDE_FILE, NULL);
	last = node;

	// ʣå롣
	scope = node->getFirstChild();
	while (scope != 0) {
		if (token.compare(scope->toString()) == 0) {
			cerr << p.getStreamLocation() << ' ' 
			     << (Message("Include file % was already specified (ignored).",
			                 "󥯥롼ɥե %s ʣꤵޤ (̵뤷ޤ)") << token.c_str()) << endl;
			return;
			}
		scope = scope->getNext();
		}

	node->addChild(new Directory(token));
	}

//
// TCP_CRE_REP -- TCP ո
//

DECLARE_API (TCP_CRE_REP, "TCP_CRE_REP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP_REP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "repatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", "}", NULL);
	}

//
// VRID_TCP_REP -- TCP ո ID ͽ
//

DECLARE_API (VRID_TCP_REP, "VRID_TCP_REP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP_REP);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVED_ID], token, TCP_REP);
	(*node)["position"] = p.getStreamLocation();
	}

//
// TCP_CRE_CEP -- TCP ̿ü
//

DECLARE_API (TCP_CRE_CEP, "TCP_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr,sbuf,sbufsz,rbuf,rbufsz,callback");
	p.getToken("}");
	}

//
// VRID_TCP_CEP -- TCP ̿ü ID ͽ
//

DECLARE_API (VRID_TCP_CEP, "VRID_TCP_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP_CEP);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVED_ID], token, TCP_CEP);
	(*node)["position"] = p.getStreamLocation();
	}

//
// UDP_CRE_CEP -- UDP ̿ü
//

DECLARE_API (UDP_CRE_CEP, "UDP_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, UDP_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", ",", NULL);
	parseParameters(p, node, "callback");
	p.getToken("}", NULL);
	}

//
// VRID_UDP_CEP -- UDP ̿ü ID ͽ
//

DECLARE_API (VRID_UDP_CEP, "VRID_UDP_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, UDP_CEP);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVED_ID], token, UDP_CEP);
	(*node)["position"] = p.getStreamLocation();
	}

//
// TCP6_CRE_REP -- TCP/IPv6 ո
//

DECLARE_API (TCP6_CRE_REP, "TCP6_CRE_REP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP6_REP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "repatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", "}", NULL);
	}

//
// VRID_TCP6_REP -- TCP/IPv6 ո ID ͽ
//

DECLARE_API (VRID_TCP6_REP, "VRID_TCP6_REP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP6_REP);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVED_ID], token, TCP6_REP);
	(*node)["position"] = p.getStreamLocation();
	}

//
// TCP6_CRE_CEP -- TCP/IPv6 ̿ü
//

DECLARE_API (TCP6_CRE_CEP, "TCP6_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP6_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr,sbuf,sbufsz,rbuf,rbufsz,callback");
	p.getToken("}");
	}

//
// VRID_TCP6_CEP -- TCP/IPv6 ̿ü ID ͽ
//

DECLARE_API (VRID_TCP6_CEP, "VRID_TCP6_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP6_CEP);
	(*node)["position"] = p.getStreamLocation();
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVED_ID], token, TCP6_CEP);
	(*node)["position"] = p.getStreamLocation();
	}

//
// UDP6_CRE_CEP -- UDP/IPv6 ̿ü
//

DECLARE_API (UDP6_CRE_CEP, "UDP6_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, UDP6_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", ",", NULL);
	parseParameters(p, node, "callback");
	p.getToken("}", NULL);
	}

//
// VRID_UDP6_CEP -- UDP/IPv6 ̿ü ID ͽ
//

DECLARE_API (VRID_UDP6_CEP, "VRID_UDP6_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, UDP6_CEP);
	(*node)["_reserved"] = 1;

	node = allocate(container[RESERVED_ID], token, UDP6_CEP);
	(*node)["position"] = p.getStreamLocation();
	}

//
// IPSEC_VSET_SPD -- ƥݥꥷΥå
//

DECLARE_API (IPSEC_VSET_SPD, "IPSEC_VSET_SPD")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, IPSEC_SET_UP_SPD);
	(*node)["position"] = p.getStreamLocation();

//	p.getToken(",", "{", NULL);
//	parseParameters(p, node, "dir,srcipaddr,srcportno,dstipaddr,dstportno,policy");
//	p.getToken("}");

	p.getToken(",", "{", "{", NULL);
	parseParameters(p, node, "dir");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "srcipaddr,srcportno");
	p.getToken("}", ",", "{", NULL);
	parseParameters(p, node, "dstipaddr,dstportno");
	p.getToken("}", ",", NULL);
	parseParameters(p, node, "prefs,prefd,proto");
	p.getToken("}", ",", NULL);
	parseParameters(p, node, "policy,ipproto,level,id");
	p.getToken("}", NULL);

	}

//
// IPSEC_VSET_SAD -- ƥΥå
//

DECLARE_API (IPSEC_VSET_SAD, "IPSEC_VSET_SAD")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, IPSEC_SET_UP_SAD);
	(*node)["position"] = p.getStreamLocation();

//	p.getToken(",", "{", NULL);
//	parseParameters(p, node, "dir,srcipaddr,srcportno,dstipaddr,dstportno,policy");
//	p.getToken("}");

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "srcipaddr,dstipaddr");
	p.getToken(",", NULL);
	parseParameters(p, node, "ipproto,spi,reqid,alg_enc");
	p.getToken(",", NULL);
	parseParameters(p, node, "key_enc");
	p.getToken("}", NULL);

	}
